#ifndef __NRF24L01_H__
#define __NRF24L01_H__

#include <STC12C5A60S2.H>
#include <intrins.h>

#define uchar unsigned char
#define uint  unsigned int

#define MODE 1  //MODE=1ʱ Ϊʹ   MODE=0ʱ  Ϊմ
//****************************************IO˿ڶ***************************************
sbit  MISO = P3 ^ 2;
sbit  MOSI = P3 ^ 4;
sbit  SCK  = P3 ^ 1;
sbit  CE   = P3 ^ 0;
sbit  CSN  = P3 ^ 3;
sbit  IRQ  = P3 ^ 5;

//sbit  MISO = P0 ^ 4;
//sbit  MOSI = P0 ^ 3;
//sbit  SCK  = P0 ^ 2;
//sbit  CE   = P0 ^ 0;
//sbit  CSN  = P0 ^ 1;
//sbit  IRQ  = P0 ^ 5;
//******************************************************************************************
uchar bdata sta;   //״̬־
sbit RX_DR  = sta ^ 6;
sbit TX_DS  = sta ^ 5;
sbit MAX_RT = sta ^ 4;
//*********************************************NRF24L01*************************************
#define TX_ADR_WIDTH    5    // 5 uints TX address width
#define RX_ADR_WIDTH    5    // 5 uints RX address width
#define TX_PLOAD_WIDTH  5    // 5 uints TX payload
#define RX_PLOAD_WIDTH  5    // 5 uints TX payload
uchar const TX_ADDRESS[TX_ADR_WIDTH] = {0x34, 0x43, 0x10, 0x10, 0x01}; //صַ
uchar const RX_ADDRESS[RX_ADR_WIDTH] = {0x34, 0x43, 0x10, 0x10, 0x01}; //յַ
uchar data Tx_Buf[TX_PLOAD_WIDTH] = {0xff, 0xee, 0x11, 0x22, 0x33};//
uchar Rx_Buf[RX_PLOAD_WIDTH];//
//***************************************NRF24L01Ĵָ*******************************************************
#define READ_REG        0x00   // Ĵָ
#define WRITE_REG       0x20  // дĴָ
#define RD_RX_PLOAD     0x61   // ȡָ
#define WR_TX_PLOAD     0xA0   // дָ
#define FLUSH_TX        0xE1  // ϴ FIFOָ
#define FLUSH_RX        0xE2   // ϴ FIFOָ
#define REUSE_TX_PL     0xE3   // ظװָ
#define NOP             0xFF   // 
//*************************************SPI(nRF24L01)Ĵַ****************************************************
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
/******************************************ʱ********************************************************/
//ʱ
void Delay(unsigned int s)
{
    unsigned int i, j;
    for(i = 0; i < 1000; i++)for(j = 0; j < s; j++);
}
//ʱ
void delay_ms(unsigned int x)
{
    unsigned int i, j;
    i = 0;
    for(i = 0; i < x; i++)
    {
        j = 108;;
        while(j--);
    }
}
/************************************IO ģSPI ************************************************/
uchar SPI_RW(uchar byte)
{
    uchar bit_ctr;
    for(bit_ctr = 0; bit_ctr < 8; bit_ctr++)
    {
        MOSI = (byte & 0x80);

        byte = (byte << 1);
        SCK = 1;
        byte |= MISO;
        //led=MISO;Delay(150);
        SCK = 0;
    }
    return(byte);
}
uchar SPI_RW_Reg  (uchar  reg, uchar value) // ĴREGдһֽڣͬʱ״ֽ̬
{
    uchar status;
    CSN = 0;
    status = SPI_RW(reg);
    SPI_RW(value);
    CSN = 1;
    return(status);
}
uchar SPI_Read (uchar  reg )
{
    uchar reg_val;
    CSN = 0;
    SPI_RW(reg);
    reg_val = SPI_RW(0);
    CSN = 1;
    return(reg_val);
}
uchar SPI_Write_Buf(uchar reg, uchar *pBuf, uchar bytes)
{
    uchar status, byte_ctr;
    CSN = 0;                   // Set CSN low, init SPI tranaction
    status = SPI_RW(reg);    // Select register to write to and read status byte
    for(byte_ctr = 0; byte_ctr < bytes; byte_ctr++) // then write all byte in buffer(*pBuf)
        SPI_RW(*pBuf++);
    CSN = 1;                 // Set CSN high again
    return(status);          // return nRF24L01 status byte
}
#if MODE
/*****************************************ģ*****ʽ***********************************************/
void TX_Mode(void)
{
    CE = 0;

    SPI_RW_Reg(FLUSH_TX, 0x00);
    SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // Writes TX_Address to nRF24L01
    SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // RX_Addr0 same as TX_Adr for Auto.Ack
    SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      // Enable Auto.Ack:Pipe0
    SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  // Enable Pipe0
    SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x1a); // 500us + 86us, 10 retrans...1a
    SPI_RW_Reg(WRITE_REG + RF_CH, 40);        // Select RF channel 40
    SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);   // TX_PWR:0dBm, Datarate:1Mbps, LNA:HCURR
    SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ2ֽ
    SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);
    CE = 1;
    delay_ms(100);
}
void Transmit(unsigned char *tx_buf)
{
    CE = 0; //StandBy Iģʽ
    SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
    SPI_RW_Reg(FLUSH_TX, 0x00);
    SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH);     // װ
    SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);      // IRQշжӦ16λCRC
    CE = 1; //øCEݷ
    delay_ms(150);
}
#else
/*****************************************ģ*****ʽ***********************************************/
uchar SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
{
    uchar status, uchar_ctr;

    CSN = 0;                      // Set CSN low, init SPI tranaction
    status = SPI_RW(reg);         // Select register to write to and read status uchar

    for(uchar_ctr = 0; uchar_ctr < uchars; uchar_ctr++)
        pBuf[uchar_ctr] = SPI_RW(0);    //

    CSN = 1;
    return(status);                    // return nRF24L01 status uchar
}
/******************************************************************************************************/
/*unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
/*ܣݶȡrx_bufջ
/******************************************************************************************************/
unsigned char nRF24L01_RxPacket(unsigned char *rx_buf)
{
    unsigned char revale = 0;
    sta = SPI_Read(STATUS); // ȡ״̬Ĵжݽ״
    if(RX_DR)    // жǷյ
    {
        //CE = 0;    //SPIʹ
        SPI_Read_Buf(RD_RX_PLOAD, rx_buf, RX_PLOAD_WIDTH); // read receive payload from RX_FIFO buffer
        revale = 1;  //ȡɱ־
        //Delay(100);
    }
    SPI_RW_Reg(WRITE_REG + STATUS, sta); //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
    return revale;
}
/****************************************************************************************************/
/*void RX_Mode(void)
/*ܣݽ
/****************************************************************************************************/
void RX_Mode(void)
{
    CE = 0;

    SPI_RW_Reg(FLUSH_RX, 0x00);
    SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // Writes TX_Address to nRF24L01
    SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // RX_Addr0 same as TX_Adr for Auto.Ack

    SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      // Enable Auto.Ack:Pipe0
    SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  // Enable Pipe0
    SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x1a); // 500us + 86us, 10 retrans...1a
    SPI_RW_Reg(WRITE_REG + RF_CH, 40);        // Select RF channel 40
    SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ2ֽ
    SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);   // TX_PWR:0dBm, Datarate:1Mbps, LNA:HCURR
    SPI_RW_Reg(WRITE_REG + CONFIG, 0x0F);
    CE = 1;
    delay_ms(130);
}
//************************************ڳʼ*********************************************************
void StartUART( void )
{
    //9600
    SCON = 0x50;
    TMOD = 0x20;
    TH1 = 0xFD;
    TL1 = 0xFD;
    PCON = 0x00;
    TR1 = 1;
}
//************************************ͨڽյݷ͸PC**************************************
void R_S_Byte(uchar R_Byte)
{
    SBUF = R_Byte;
    while( TI == 0 );    //ѯ
    TI = 0;
}
#endif
//=========================================================================================//
#endif